/*
Copyright Kumori.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	kumoriv1 "gitlab.com/mandanga-public/sub1/sub2/client-go/pkg/apis/kumori/v1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeKukuLinks implements KukuLinkInterface
type FakeKukuLinks struct {
	Fake *FakeKumoriV1
	ns   string
}

var kukulinksResource = schema.GroupVersionResource{Group: "kumori.systems", Version: "v1", Resource: "kukulinks"}

var kukulinksKind = schema.GroupVersionKind{Group: "kumori.systems", Version: "v1", Kind: "KukuLink"}

// Get takes name of the kukuLink, and returns the corresponding kukuLink object, and an error if there is any.
func (c *FakeKukuLinks) Get(name string, options v1.GetOptions) (result *kumoriv1.KukuLink, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(kukulinksResource, c.ns, name), &kumoriv1.KukuLink{})

	if obj == nil {
		return nil, err
	}
	return obj.(*kumoriv1.KukuLink), err
}

// List takes label and field selectors, and returns the list of KukuLinks that match those selectors.
func (c *FakeKukuLinks) List(opts v1.ListOptions) (result *kumoriv1.KukuLinkList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(kukulinksResource, kukulinksKind, c.ns, opts), &kumoriv1.KukuLinkList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &kumoriv1.KukuLinkList{ListMeta: obj.(*kumoriv1.KukuLinkList).ListMeta}
	for _, item := range obj.(*kumoriv1.KukuLinkList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested kukuLinks.
func (c *FakeKukuLinks) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(kukulinksResource, c.ns, opts))

}

// Create takes the representation of a kukuLink and creates it.  Returns the server's representation of the kukuLink, and an error, if there is any.
func (c *FakeKukuLinks) Create(kukuLink *kumoriv1.KukuLink) (result *kumoriv1.KukuLink, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(kukulinksResource, c.ns, kukuLink), &kumoriv1.KukuLink{})

	if obj == nil {
		return nil, err
	}
	return obj.(*kumoriv1.KukuLink), err
}

// Update takes the representation of a kukuLink and updates it. Returns the server's representation of the kukuLink, and an error, if there is any.
func (c *FakeKukuLinks) Update(kukuLink *kumoriv1.KukuLink) (result *kumoriv1.KukuLink, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(kukulinksResource, c.ns, kukuLink), &kumoriv1.KukuLink{})

	if obj == nil {
		return nil, err
	}
	return obj.(*kumoriv1.KukuLink), err
}

// Delete takes name of the kukuLink and deletes it. Returns an error if one occurs.
func (c *FakeKukuLinks) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(kukulinksResource, c.ns, name), &kumoriv1.KukuLink{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeKukuLinks) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(kukulinksResource, c.ns, listOptions)

	_, err := c.Fake.Invokes(action, &kumoriv1.KukuLinkList{})
	return err
}

// Patch applies the patch and returns the patched kukuLink.
func (c *FakeKukuLinks) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *kumoriv1.KukuLink, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(kukulinksResource, c.ns, name, pt, data, subresources...), &kumoriv1.KukuLink{})

	if obj == nil {
		return nil, err
	}
	return obj.(*kumoriv1.KukuLink), err
}
